"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateDeploymentNames = exports.isDeploymentRequest = exports.deploymentRegex = void 0;
exports.deploymentRegex = /\/subscriptions\/.*?\/resourceGroups\/.*?\/providers\/Microsoft\.Resources\/deployments\/(.+?)[?/].*/i;
function isDeploymentRequest(req) {
    return exports.deploymentRegex.test(req.originalUrl);
}
exports.isDeploymentRequest = isDeploymentRequest;
function updateDeploymentNames(requests, req, seenDeployments) {
    var deployment = requests.find(function (mockRequest) {
        var matches = mockRequest.url.match(exports.deploymentRegex);
        // We haven't seen this deployment request before
        return matches !== null && seenDeployments.indexOf(matches[1].toLocaleUpperCase()) === -1;
    });
    var newDeploymentName = req.originalUrl.match(exports.deploymentRegex)[1];
    // We've already updated the requests for this deployment
    if (!deployment || seenDeployments.indexOf(newDeploymentName.toLocaleUpperCase()) !== -1) {
        return [requests, seenDeployments];
    }
    var oldDeploymentName = deployment.url.match(exports.deploymentRegex)[1];
    var json = JSON.stringify(requests);
    var newRequests = JSON.parse(replaceAll(json, oldDeploymentName, newDeploymentName));
    seenDeployments.push(oldDeploymentName.toLocaleUpperCase());
    seenDeployments.push(newDeploymentName.toLocaleUpperCase());
    return [newRequests, seenDeployments];
}
exports.updateDeploymentNames = updateDeploymentNames;
function replaceAll(input, searchValue, replaceValue) {
    return input.replace(new RegExp(regexEscape(searchValue), "g"), replaceValue);
}
function regexEscape(str) {
    return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
}
//# sourceMappingURL=helpers.js.map